
/*  A Bison parser, made from parse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	CLASS	257
#define	FROM	258
#define	CONST	259
#define	VOID	260
#define	STRUCT	261
#define	UNION	262
#define	ENUM	263
#define	THREEDOTS	264
#define	SIGNED	265
#define	UNSIGNED	266
#define	LONG	267
#define	SHORT	268
#define	INT	269
#define	FLOAT	270
#define	DOUBLE	271
#define	CHAR	272
#define	TOKEN	273
#define	NUMBER	274
#define	TYPETOKEN	275
#define	ARRAY_DIM	276
#define	CCODE	277
#define	HTCODE	278
#define	PHCODE	279
#define	HCODE	280
#define	ACODE	281
#define	ATCODE	282
#define	PUBLIC	283
#define	PRIVATE	284
#define	PROTECTED	285
#define	ARGUMENT	286
#define	VIRTUAL	287
#define	SIGNAL	288
#define	OVERRIDE	289

#line 21 "parse.y"


#include "config.h"
#include <glib.h>
#include <stdio.h>
#include <string.h>

#include "treefuncs.h"
#include "main.h"
#include "util.h"

#define _(x) (x)
	
GList *nodes = NULL;

static GList *class_nodes = NULL;
Node *class = NULL;

static GList *typestack = NULL;
static int stars = 0;
static GList *funcargs = NULL;
static GList *checks = NULL;
static int has_self = FALSE;
static int vararg = FALSE;

/* destructor and initializer for variables */
static char *destructor = NULL;
static int destructor_line = 0;
static gboolean destructor_simple = TRUE;
static char *initializer = NULL;
static int initializer_line = 0;

static char *onerror = NULL;
static char *defreturn = NULL;

static GList *gtktypes = NULL;

/* this can be a global as we will only do one function at a time
   anyway */
static int the_scope = NO_SCOPE;

void free(void *ptr);
int yylex(void);

extern int ccode_line;
extern int line_no;

extern char *yytext;

static void
yyerror(char *str)
{
	char *out=NULL;
	char *p;
	
	if(strcmp(yytext,"\n")==0) {
		out=g_strconcat("Error: ",str," before newline",NULL);
	} else if(yytext[0]=='\0') {
		out=g_strconcat("Error: ", str, " at end of input", NULL);
	} else {
		char *tmp = g_strdup(yytext);
		while((p=strchr(tmp, '\n')))
			*p='.';

		out=g_strconcat("Error: ", str, " before '", tmp, "'", NULL);
		g_free(tmp);
	}

	fprintf(stderr, "%s:%d: %s\n", filename, line_no, out);
	g_free(out);
	
	exit(1);
}

static Type *
pop_type(void)
{
	Type *type = typestack->data;
	typestack = g_list_remove(typestack,typestack->data);
	return type;
}

static void
push_variable(char *name, int scope, int line_no, char *postfix)
{
	Node *var;
	Type *type = pop_type();

	type->postfix = postfix;
	
	var = new_variable(scope, type, name, line_no,
			   destructor, destructor_line,
			   destructor_simple,
			   initializer, initializer_line);
	class_nodes = g_list_append(class_nodes, var);
}

static void
push_function(int scope, int method, char *oid, char *id,
	      GString *cbuf, int line_no, int ccode_line,
	      gboolean vararg, GList *flags)
{
	Node *node;
	Type *type;
	char *c_cbuf;
       
	if(method!=INIT_METHOD && method!=CLASS_INIT_METHOD) {
		type = pop_type();
	} else {
		type = (Type *)new_type(0,g_strdup("void"),NULL);
	}
	
	/* a complicated and ugly test to figure out if we have
	   the wrong number of types for a signal */
	if((method == SIGNAL_FIRST_METHOD ||
	    method == SIGNAL_LAST_METHOD) &&
	   g_list_length(gtktypes) != g_list_length(funcargs) &&
	   !(g_list_length(funcargs) == 1 &&
	     g_list_length(gtktypes) == 2 &&
	     strcmp(gtktypes->next->data, "NONE")==0)) {
		print_error(TRUE, _("The number of GTK arguments and "
				    "function arguments for a signal "
				    "don't seem to match"), line_no);
	}
	if(g_list_length(gtktypes) > 2) {
		GList *li;
		for(li = gtktypes->next; li; li = li->next) {
			if(strcmp(li->data, "NONE")==0) {
				print_error(FALSE,
					    _("NONE can only appear in an "
					      "argument list by itself"),
					    line_no);
			}
		}
	}
	if(cbuf) {
		char *p;
		c_cbuf = p = cbuf->str;
		while(p && *p && (*p==' ' || *p=='\t' || *p=='\n' || *p=='\r'))
			p++;
		if(!p || !*p)
			c_cbuf = NULL;
	} else
		c_cbuf = NULL;

	node = new_method(scope, method, type, oid, gtktypes, flags,
			  id, funcargs, onerror, defreturn, c_cbuf, line_no,
			  ccode_line, vararg);

	if(cbuf)
		g_string_free(cbuf,
			      /*only free segment if we haven't passed it
				above */
			      c_cbuf?FALSE:TRUE);
	gtktypes = NULL;
	funcargs = NULL;

	onerror = NULL;
	defreturn = NULL;

	class_nodes = g_list_append(class_nodes, node);
}

static void
free_all_global_state(void)
{
	g_free(onerror);
	onerror = NULL;
	g_free(defreturn);
	defreturn = NULL;

	g_list_foreach(gtktypes, (GFunc)g_free, NULL);
	g_list_free(gtktypes);
	gtktypes = NULL;

	free_node_list(funcargs);
	funcargs = NULL;
}

static void
push_funcarg(char *name, char *postfix)
{
	Node *node;
	Type *type = pop_type();

	type->postfix = postfix;
	
	node = new_funcarg(type, name, checks);
	checks = NULL;
	
	funcargs = g_list_append(funcargs, node);
}

static void
push_init_arg(char *name, int is_class)
{
	Node *node;
	Node *type;
	char *tn;
	
	if(is_class)
		tn = g_strconcat(((Class *)class)->otype,":Class",NULL);
	else
		tn = g_strdup(((Class *)class)->otype);

	type = new_type(1,tn,NULL);
	node = new_funcarg((Type *)type,name,NULL);
	funcargs = g_list_prepend(funcargs, node);
}

static void
push_self(char *id)
{
	Node *node;
	Node *type;
	GList *ch = NULL;
	type = new_type(1,g_strdup(((Class *)class)->otype),NULL);
	ch = g_list_append(ch,new_check(NULL_CHECK,NULL));
	ch = g_list_append(ch,new_check(TYPE_CHECK,NULL));
	node = new_funcarg((Type *)type,id,ch);
	funcargs = g_list_prepend(funcargs, node);
}

static Variable *
find_var_or_die(const char *id, int line)
{
	GList *li;
	char *s;

	for(li = class_nodes; li != NULL; li = li->next) {
		Variable *var;
		Node *node = li->data;
		if(node->type != VARIABLE_NODE)
			continue;
		var = li->data;
		if(strcmp(var->id, id)==0)
			return var;
	}

	s = g_strdup_printf(_("Variable %s not defined here"), id);
	print_error(FALSE, s, line);

	g_assert_not_reached();
	return NULL;
}

static gboolean
set_return_value(char *type, char *val)
{
	if(strcmp(type, "onerror")==0) {
		if(!onerror) {
			onerror = val;
			return TRUE;
		} else
			return FALSE;
	} else if(strcmp(type, "defreturn")==0) {
		if(!defreturn) {
			defreturn = val;
			return TRUE;
		} else
			return FALSE;
	}
	return FALSE;
}


#line 288 "parse.y"
typedef union {
	char *id;
	GString *cbuf;
	GList *list;
	int line;
	int sigtype;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		242
#define	YYFLAG		-32768
#define	YYNTBASE	49

#define YYTRANSLATE(x) ((unsigned)(x) <= 289 ? yytranslate[x] : 86)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    47,     2,     2,     2,     2,     2,     2,    40,
    41,    43,     2,    44,    48,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    38,    46,
    39,    45,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    36,    42,    37,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     7,    10,    12,    14,    16,    18,    20,    22,
    24,    27,    29,    34,    38,    43,    46,    48,    50,    52,
    54,    56,    58,    60,    62,    65,    69,    72,    76,    79,
    82,    84,    86,    87,    93,   100,   112,   121,   127,   133,
   135,   139,   140,   144,   146,   148,   151,   153,   156,   159,
   162,   164,   167,   170,   172,   174,   176,   178,   181,   183,
   185,   188,   190,   193,   195,   197,   199,   201,   203,   206,
   208,   211,   213,   217,   221,   224,   226,   231,   235,   237,
   240,   242,   253,   265,   275,   285,   294,   306,   315,   321,
   324,   329,   330,   332,   335,   337,   339,   343,   345,   349,
   351,   355,   357,   360,   364,   371,   379,   382,   384,   386,
   389,   392,   396,   400,   404,   408,   410,   413
};

static const short yyrhs[] = {    51,
    52,    51,     0,    52,    51,     0,    51,    52,     0,    52,
     0,    23,     0,    26,     0,    24,     0,    25,     0,    27,
     0,    28,     0,    51,    50,     0,    50,     0,    53,    36,
    54,    37,     0,    53,    36,    37,     0,     3,    21,     4,
    21,     0,    54,    55,     0,    55,     0,    76,     0,    60,
     0,    61,     0,    38,     0,    29,     0,    30,     0,    31,
     0,    19,    19,     0,    19,    36,    23,     0,    39,    85,
     0,    39,    36,    23,     0,    57,    58,     0,    58,    57,
     0,    58,     0,    57,     0,     0,    56,    65,    19,    59,
    38,     0,    56,    65,    19,    22,    59,    38,     0,    32,
    63,    62,    19,    19,    36,    23,    19,    36,    23,    38,
     0,    32,    63,    62,    19,    19,    36,    23,    38,     0,
    32,    63,    62,    19,    19,     0,    19,    40,    19,    65,
    41,     0,    19,     0,    40,    64,    41,     0,     0,    19,
    42,    64,     0,    19,     0,    66,     0,     5,    66,     0,
    67,     0,    67,    70,     0,    12,    68,     0,    11,    68,
     0,    68,     0,    12,    18,     0,    11,    18,     0,    18,
     0,    17,     0,    16,     0,    19,     0,    69,    19,     0,
    21,     0,     6,     0,    13,    15,     0,    13,     0,    14,
    15,     0,    14,     0,    15,     0,     9,     0,     8,     0,
     7,     0,    43,    70,     0,    43,     0,    19,    73,     0,
    73,     0,    56,    19,    73,     0,    19,    56,    73,     0,
    56,    73,     0,    71,     0,    19,    40,    74,    41,     0,
    74,    44,    19,     0,    19,     0,    36,    23,     0,    38,
     0,    34,    63,    72,    65,    19,    40,    79,    41,    77,
    75,     0,    56,    34,    63,    71,    65,    19,    40,    79,
    41,    77,    75,     0,    33,    56,    65,    19,    40,    79,
    41,    77,    75,     0,    56,    33,    65,    19,    40,    79,
    41,    77,    75,     0,    33,    65,    19,    40,    79,    41,
    77,    75,     0,    35,    40,    21,    41,    65,    19,    40,
    79,    41,    77,    75,     0,    56,    65,    19,    40,    79,
    41,    77,    75,     0,    19,    40,    19,    41,    75,     0,
    19,    78,     0,    19,    78,    19,    78,     0,     0,    85,
     0,    36,    23,     0,     6,     0,    19,     0,    19,    44,
    80,     0,    80,     0,    81,    44,    10,     0,    81,     0,
    81,    44,    82,     0,    82,     0,    65,    19,     0,    65,
    19,    22,     0,    65,    19,    40,    19,    83,    41,     0,
    65,    19,    22,    40,    19,    83,    41,     0,    83,    84,
     0,    84,     0,    19,     0,    45,    85,     0,    46,    85,
     0,    45,    39,    85,     0,    46,    39,    85,     0,    39,
    39,    85,     0,    47,    39,    85,     0,    20,     0,    48,
    20,     0,    19,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   306,   307,   308,   309,   312,   318,   324,   330,   336,   342,
   350,   351,   354,   359,   366,   371,   372,   375,   376,   377,
   378,   381,   382,   383,   386,   399,   415,   419,   427,   428,
   429,   430,   431,   437,   440,   444,   479,   507,   572,   581,
   587,   588,   591,   594,   600,   601,   609,   613,   620,   623,
   626,   629,   632,   635,   638,   641,   644,   647,   651,   654,
   659,   662,   665,   668,   671,   676,   679,   682,   687,   688,
   692,   704,   710,   722,   734,   737,   743,   748,   751,   756,
   757,   761,   772,   783,   794,   805,   816,   822,   827,   848,
   859,   878,   884,   885,   891,   892,   903,   913,   916,   917,
   920,   921,   924,   927,   930,   938,   948,   949,   952,   965,
   969,   973,   977,   981,   985,   991,   992,   996
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","CLASS",
"FROM","CONST","VOID","STRUCT","UNION","ENUM","THREEDOTS","SIGNED","UNSIGNED",
"LONG","SHORT","INT","FLOAT","DOUBLE","CHAR","TOKEN","NUMBER","TYPETOKEN","ARRAY_DIM",
"CCODE","HTCODE","PHCODE","HCODE","ACODE","ATCODE","PUBLIC","PRIVATE","PROTECTED",
"ARGUMENT","VIRTUAL","SIGNAL","OVERRIDE","'{'","'}'","';'","'='","'('","')'",
"'|'","'*'","','","'>'","'<'","'!'","'-'","prog","ccode","ccodes","class","classdec",
"classcode","thing","scope","destructor","initializer","varoptions","variable",
"argument","argtype","flags","flaglist","type","type1","type2","integer","tspecifier",
"stars","simplesigtype","fullsigtype","sigtype","tokenlist","codenocode","method",
"returnvals","retcode","funcargs","arglist","arglist1","arg","checklist","check",
"numtok", NULL
};
#endif

static const short yyr1[] = {     0,
    49,    49,    49,    49,    50,    50,    50,    50,    50,    50,
    51,    51,    52,    52,    53,    54,    54,    55,    55,    55,
    55,    56,    56,    56,    57,    57,    58,    58,    59,    59,
    59,    59,    59,    60,    60,    61,    61,    61,    62,    62,
    63,    63,    64,    64,    65,    65,    66,    66,    67,    67,
    67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
    68,    68,    68,    68,    68,    69,    69,    69,    70,    70,
    71,    71,    72,    72,    72,    72,    73,    74,    74,    75,
    75,    76,    76,    76,    76,    76,    76,    76,    76,    77,
    77,    77,    78,    78,    79,    79,    79,    79,    80,    80,
    81,    81,    82,    82,    82,    82,    83,    83,    84,    84,
    84,    84,    84,    84,    84,    85,    85,    85
};

static const short yyr2[] = {     0,
     3,     2,     2,     1,     1,     1,     1,     1,     1,     1,
     2,     1,     4,     3,     4,     2,     1,     1,     1,     1,
     1,     1,     1,     1,     2,     3,     2,     3,     2,     2,
     1,     1,     0,     5,     6,    11,     8,     5,     5,     1,
     3,     0,     3,     1,     1,     2,     1,     2,     2,     2,
     1,     2,     2,     1,     1,     1,     1,     2,     1,     1,
     2,     1,     2,     1,     1,     1,     1,     1,     2,     1,
     2,     1,     3,     3,     2,     1,     4,     3,     1,     2,
     1,    10,    11,     9,     9,     8,    11,     8,     5,     2,
     4,     0,     1,     2,     1,     1,     3,     1,     3,     1,
     3,     1,     2,     3,     6,     7,     2,     1,     1,     2,
     2,     3,     3,     3,     3,     1,     2,     1
};

static const short yydefact[] = {     0,
     0,     5,     7,     8,     6,     9,    10,    12,     0,     4,
     0,     0,    11,     3,     2,     0,     0,     1,     0,    22,
    23,    24,    42,     0,    42,     0,    14,    21,     0,    17,
     0,    19,    20,    18,    15,     0,     0,     0,     0,    60,
    68,    67,    66,     0,     0,    62,    64,    65,    56,    55,
    54,    57,    59,     0,     0,    45,    47,    51,     0,     0,
     0,    13,    16,     0,    42,     0,     0,    44,     0,    40,
     0,    46,    53,    50,    52,    49,    61,    63,     0,     0,
    70,    48,    58,     0,     0,    76,     0,    72,     0,     0,
     0,    33,     0,     0,    41,     0,     0,     0,     0,    69,
     0,     0,     0,    71,     0,    75,     0,     0,     0,     0,
     0,     0,    33,     0,     0,    32,    31,     0,     0,    81,
    89,    43,     0,    38,     0,    60,    57,     0,     0,    98,
   100,   102,    79,     0,    74,    73,     0,     0,     0,     0,
    25,     0,     0,   118,   116,     0,     0,    27,     0,    29,
    30,    34,    80,     0,     0,     0,     0,   103,    92,     0,
    77,     0,     0,     0,     0,     0,    26,    35,    28,   117,
    92,    39,     0,    92,    97,   104,     0,     0,     0,    99,
   101,    78,     0,     0,    92,     0,     0,     0,    37,     0,
     0,     0,     0,    90,    93,    86,    92,     0,     0,     0,
    88,     0,    84,     0,   109,     0,     0,     0,     0,     0,
   108,    94,     0,     0,    92,    85,    92,     0,     0,     0,
     0,   110,     0,   111,     0,   105,   107,    91,    82,     0,
     0,    36,   106,   114,   112,   113,   115,    87,    83,     0,
     0,     0
};

static const short yydefgoto[] = {   240,
     8,     9,    10,    11,    29,    30,    31,   116,   117,   118,
    32,    33,    71,    38,    69,   128,    56,    57,    58,    59,
    82,    86,    87,    88,   134,   121,    34,   179,   194,   129,
   130,   131,   132,   210,   211,   195
};

static const short yypact[] = {   136,
   -17,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   136,   167,
   -16,    13,-32768,   167,   167,   150,    15,   167,    19,-32768,
-32768,-32768,    27,   137,    27,    37,-32768,-32768,   170,-32768,
   107,-32768,-32768,-32768,-32768,    25,    61,    98,   254,-32768,
-32768,-32768,-32768,   263,   269,   114,   118,-32768,-32768,-32768,
-32768,-32768,-32768,   221,   116,-32768,   104,-32768,   138,    73,
   151,-32768,-32768,   221,    27,   154,   133,   155,   157,   156,
   159,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   187,   184,
   104,-32768,-32768,   146,   212,-32768,   221,-32768,   200,   229,
   239,    43,    96,    61,-32768,   245,   255,   240,   238,-32768,
   246,   260,   266,-32768,    -8,-32768,   270,   221,   248,    -8,
   221,    36,     3,    -1,   238,   251,   272,   256,   273,-32768,
-32768,-32768,   221,   257,   238,   258,    57,   276,   259,-32768,
   253,-32768,-32768,    64,-32768,-32768,   252,   279,   238,   282,
-32768,   280,   264,-32768,-32768,   281,   285,-32768,   265,-32768,
-32768,-32768,-32768,   267,   284,   268,   221,     5,   291,   204,
-32768,   292,   238,   274,   271,   275,-32768,-32768,-32768,-32768,
   291,-32768,   -10,   291,-32768,   277,   294,    18,    96,-32768,
-32768,-32768,   278,   238,   291,   238,    96,   286,-32768,    96,
   297,    91,   295,   301,-32768,-32768,   291,   283,    96,   287,
-32768,   298,-32768,    91,-32768,   288,    -5,    10,   290,    29,
-32768,-32768,    18,    96,   291,-32768,   291,   293,    50,     4,
     4,-32768,     4,-32768,     4,-32768,-32768,-32768,-32768,    96,
    96,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   323,
   325,-32768
};

static const short yypgoto[] = {-32768,
    69,   117,   317,-32768,-32768,   303,   -21,   213,   217,   222,
-32768,-32768,-32768,   -19,   242,   -23,   299,-32768,   126,-32768,
   261,   243,-32768,   -24,-32768,  -174,-32768,  -164,   124,  -113,
   182,-32768,   180,   139,  -120,  -114
};


#define	YYLAST		343


static const short yytable[] = {   148,
    55,   149,    54,    12,   196,    60,   187,    66,   188,   190,
   101,   156,   201,   144,   145,   203,    17,   144,   145,    16,
   199,   112,   144,   145,   216,   165,   176,   189,   144,   145,
    79,   102,   214,   221,   146,    35,   144,   145,    85,   229,
    90,   114,   147,    67,   177,    91,   147,   205,   223,   183,
   230,   147,   231,   193,   141,   238,   239,   147,    36,   104,
   106,   112,   103,   107,   113,   147,    37,   206,   205,   226,
   198,   142,   200,   207,   208,   209,    61,    13,   135,    68,
   136,   114,   115,    13,   138,   104,    13,   140,   206,   227,
   233,    84,   222,   224,   207,   208,   209,   -96,   227,   154,
   157,    20,    21,    22,   161,   234,   235,   162,   236,   205,
   237,    39,    40,    41,    42,    43,    70,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    15,    53,    77,   206,
    18,   119,    78,   120,    80,   207,   208,   209,     1,    64,
    65,    39,    40,    41,    42,    43,    81,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    83,    53,     2,     3,
     4,     5,     6,     7,   101,    20,    21,    22,    19,    74,
    76,    89,    92,    93,    20,    21,    22,    97,    20,    21,
    22,    23,    24,    25,    26,   102,    27,    28,    19,     2,
     3,     4,     5,     6,     7,    96,    94,    95,    20,    21,
    22,    23,    24,    25,    26,    98,    62,    28,    39,    40,
    41,    42,    43,   180,    44,    45,    46,    47,    48,    49,
    50,    51,    52,    99,    53,    39,    40,    41,    42,    43,
   105,    44,    45,    46,    47,    48,    49,    50,    51,    52,
   108,    53,    39,   126,    41,    42,    43,   109,    44,    45,
    46,    47,    48,    49,    50,    51,   127,   110,    53,    40,
    41,    42,    43,   123,    44,    45,    46,    47,    48,    49,
    50,    51,    52,   124,    53,    46,    47,    48,   133,   125,
    73,    46,    47,    48,   101,   102,    75,   139,   137,   114,
   112,   163,   155,   152,   158,   153,   160,   164,   -95,   159,
   166,   168,   167,   169,   170,   171,   173,   172,   174,   178,
   182,   185,   192,   184,   186,   204,   191,   212,   197,   213,
   218,   202,   241,   215,   242,    14,   220,   217,   225,   151,
   232,    63,   150,   111,   143,   122,   228,    72,   175,   181,
     0,   100,   219
};

static const short yycheck[] = {   114,
    24,   115,    24,    21,   179,    25,   171,    31,    19,   174,
    19,   125,   187,    19,    20,   190,     4,    19,    20,    36,
   185,    19,    19,    20,   199,   139,    22,    38,    19,    20,
    54,    40,   197,    39,    36,    21,    19,    20,    60,   214,
    64,    39,    48,    19,    40,    65,    48,    19,    39,   163,
   215,    48,   217,    36,    19,   230,   231,    48,    40,    84,
    85,    19,    84,    87,    22,    48,    40,    39,    19,    41,
   184,    36,   186,    45,    46,    47,    40,     9,   103,    19,
   105,    39,    40,    15,   108,   110,    18,   111,    39,   210,
    41,    19,   207,   208,    45,    46,    47,    41,   219,   123,
    44,    29,    30,    31,    41,   220,   221,    44,   223,    19,
   225,     5,     6,     7,     8,     9,    19,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    10,    21,    15,    39,
    14,    36,    15,    38,    19,    45,    46,    47,     3,    33,
    34,     5,     6,     7,     8,     9,    43,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    19,    21,    23,    24,
    25,    26,    27,    28,    19,    29,    30,    31,    19,    44,
    45,    21,    19,    41,    29,    30,    31,    19,    29,    30,
    31,    32,    33,    34,    35,    40,    37,    38,    19,    23,
    24,    25,    26,    27,    28,    40,    42,    41,    29,    30,
    31,    32,    33,    34,    35,    19,    37,    38,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    40,    21,     5,     6,     7,     8,     9,
    19,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    41,    21,     5,     6,     7,     8,     9,    19,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    19,    21,     6,
     7,     8,     9,    19,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    19,    21,    13,    14,    15,    19,    40,
    18,    13,    14,    15,    19,    40,    18,    40,    19,    39,
    19,    40,    36,    38,    19,    23,    44,    19,    41,    41,
    19,    38,    23,    23,    20,    41,    23,    41,    41,    19,
    19,    41,    19,    40,    40,    19,    40,    23,    41,    19,
    23,    36,     0,    41,     0,     9,    39,    41,    39,   117,
    38,    29,   116,    91,   113,    94,   213,    39,   157,   160,
    -1,    81,   204
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 306 "parse.y"
{ ; ;
    break;}
case 2:
#line 307 "parse.y"
{ ; ;
    break;}
case 3:
#line 308 "parse.y"
{ ; ;
    break;}
case 4:
#line 309 "parse.y"
{ ; ;
    break;}
case 5:
#line 312 "parse.y"
{
			Node *node = new_ccode(C_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 6:
#line 318 "parse.y"
{
			Node *node = new_ccode(H_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 7:
#line 324 "parse.y"
{
			Node *node = new_ccode(HT_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 8:
#line 330 "parse.y"
{
			Node *node = new_ccode(PH_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 9:
#line 336 "parse.y"
{
			Node *node = new_ccode(A_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 10:
#line 342 "parse.y"
{
			Node *node = new_ccode(AT_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 11:
#line 350 "parse.y"
{ ; ;
    break;}
case 12:
#line 351 "parse.y"
{ ; ;
    break;}
case 13:
#line 354 "parse.y"
{
			((Class *)class)->nodes = class_nodes;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 14:
#line 359 "parse.y"
{
			((Class *)class)->nodes = NULL;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 15:
#line 366 "parse.y"
{
			class = new_class(yyvsp[-2].id,yyvsp[0].id,NULL);
						;
    break;}
case 16:
#line 371 "parse.y"
{ ; ;
    break;}
case 17:
#line 372 "parse.y"
{ ; ;
    break;}
case 18:
#line 375 "parse.y"
{ ; ;
    break;}
case 19:
#line 376 "parse.y"
{ ; ;
    break;}
case 20:
#line 377 "parse.y"
{ ; ;
    break;}
case 21:
#line 378 "parse.y"
{ ; ;
    break;}
case 22:
#line 381 "parse.y"
{ the_scope = PUBLIC_SCOPE; ;
    break;}
case 23:
#line 382 "parse.y"
{ the_scope = PRIVATE_SCOPE; ;
    break;}
case 24:
#line 383 "parse.y"
{ the_scope = PROTECTED_SCOPE; ;
    break;}
case 25:
#line 386 "parse.y"
{
			if(strcmp(yyvsp[-1].id, "destroywith")==0) {
				g_free(yyvsp[-1].id);
				destructor = yyvsp[0].id;
				destructor_line = line_no;
				destructor_simple = TRUE;
			} else {
				g_free(yyvsp[-1].id);
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
				;
    break;}
case 26:
#line 399 "parse.y"
{
			if(strcmp(yyvsp[-2].id, "destroy")==0) {
				g_free(yyvsp[-2].id);
				destructor = (yyvsp[0].cbuf)->str;
				g_string_free(yyvsp[0].cbuf, FALSE);
				destructor_line = ccode_line;
				destructor_simple = FALSE;
			} else {
				g_free(yyvsp[-2].id);
				g_string_free(yyvsp[0].cbuf, TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 27:
#line 415 "parse.y"
{
			initializer = yyvsp[0].id;
			initializer_line = ccode_line;
				;
    break;}
case 28:
#line 419 "parse.y"
{
			initializer = (yyvsp[0].cbuf)->str;
			initializer_line = ccode_line;
			g_string_free(yyvsp[0].cbuf, FALSE);
				;
    break;}
case 29:
#line 427 "parse.y"
{ ; ;
    break;}
case 30:
#line 428 "parse.y"
{ ; ;
    break;}
case 31:
#line 429 "parse.y"
{ destructor = NULL; ;
    break;}
case 32:
#line 430 "parse.y"
{ initializer = NULL; ;
    break;}
case 33:
#line 431 "parse.y"
{
			destructor = NULL;
			initializer = NULL;
					;
    break;}
case 34:
#line 437 "parse.y"
{
			push_variable(yyvsp[-2].id, the_scope,yyvsp[-4].line, NULL);
						;
    break;}
case 35:
#line 440 "parse.y"
{
			push_variable(yyvsp[-3].id, the_scope, yyvsp[-5].line, yyvsp[-2].id);
						;
    break;}
case 36:
#line 444 "parse.y"
{
			if(strcmp(yyvsp[-6].id,"get")==0 &&
			   strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,type,yyvsp[-9].list,yyvsp[-7].id,
						    (yyvsp[-4].cbuf)->str,yyvsp[-5].line,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    yyvsp[-10].line);
				g_string_free(yyvsp[-4].cbuf,FALSE);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-6].id,"set")==0 &&
				strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,type,yyvsp[-9].list,yyvsp[-7].id,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    (yyvsp[-4].cbuf)->str,yyvsp[-5].line,
						    yyvsp[-10].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				g_string_free(yyvsp[-4].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-8].id); g_free(yyvsp[-7].id);
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				g_list_foreach(yyvsp[-9].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				g_string_free(yyvsp[-4].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 37:
#line 479 "parse.y"
{
			if(strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,type,yyvsp[-6].list,yyvsp[-4].id,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    NULL,0, yyvsp[-7].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,type,yyvsp[-6].list,yyvsp[-4].id,
						    NULL,0,(yyvsp[-1].cbuf)->str,
						    yyvsp[-2].line, yyvsp[-7].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-3].id); g_free(yyvsp[-5].id);
				g_free(yyvsp[-4].id);
				g_list_foreach(yyvsp[-6].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 38:
#line 507 "parse.y"
{
			Node *node;
			char *get, *set = NULL;
			Variable *var;
			Type *type;
			char *root;
			
			if(strcmp(yyvsp[0].id,"link")!=0 &&
			   strcmp(yyvsp[0].id,"stringlink")!=0 &&
			   strcmp(yyvsp[0].id,"objectlink")!=0) {
				g_free(yyvsp[0].id); g_free(yyvsp[-2].id);
				g_free(yyvsp[-1].id);
				g_list_foreach(yyvsp[-3].list,(GFunc)g_free,NULL);
				yyerror(_("parse error"));
				YYERROR;
			}

			type = pop_type();

			var = find_var_or_die(yyvsp[-1].id, yyvsp[-4].line);
			if(var->scope == PRIVATE_SCOPE)
				root = "self->_priv";
			else
				root = "self";

			if(strcmp(yyvsp[0].id,"link")==0) {
				set = g_strdup_printf("%s->%s = ARG;",
						      root, yyvsp[-1].id);
			} else if(strcmp(yyvsp[0].id,"stringlink")==0) {
				set = g_strdup_printf("g_free(%s->%s); "
						      "%s->%s = g_strdup(ARG);",
						      root, yyvsp[-1].id,
						      root, yyvsp[-1].id);
			} else if(strcmp(yyvsp[0].id,"objectlink")==0) {
				set = g_strdup_printf(
				  "if(%s->%s) "
				   "gtk_object_unref(GTK_OBJECT(%s->%s)); "
				  "%s->%s = ARG; "
				  "if(%s->%s) "
				   "gtk_object_ref(GTK_OBJECT(%s->%s)); ",
				  root, yyvsp[-1].id,
				  root, yyvsp[-1].id,
				  root, yyvsp[-1].id,
				  root, yyvsp[-1].id,
				  root, yyvsp[-1].id);
			} else {
				g_assert_not_reached();
			}

			/* get is the same for everything */
			get = g_strdup_printf("ARG = %s->%s;", root, yyvsp[-1].id);

			g_free(yyvsp[0].id);


			if(!type)
				type = copy_type(var->vtype);

			node = new_argument(yyvsp[-2].id, type, yyvsp[-3].list,
					    yyvsp[-1].id, get, yyvsp[-4].line,
					    set, yyvsp[-4].line, yyvsp[-4].line);
			class_nodes = g_list_append(class_nodes,node);
						;
    break;}
case 39:
#line 572 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"type")!=0) {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			yyval.id = yyvsp[-4].id;
						;
    break;}
case 40:
#line 581 "parse.y"
{
			yyval.id = yyvsp[0].id;
			typestack = g_list_prepend(typestack,NULL);
						;
    break;}
case 41:
#line 587 "parse.y"
{ yyval.list = yyvsp[-1].list; ;
    break;}
case 42:
#line 588 "parse.y"
{ yyval.list = NULL; ;
    break;}
case 43:
#line 591 "parse.y"
{
			yyval.list = g_list_append(yyvsp[0].list,yyvsp[-2].id);
						;
    break;}
case 44:
#line 594 "parse.y"
{
			yyval.list = g_list_append(NULL,yyvsp[0].id);
						;
    break;}
case 45:
#line 600 "parse.y"
{ ; ;
    break;}
case 46:
#line 601 "parse.y"
{
			Type *type = typestack->data;
			char *oldname = type->name;
			type->name = g_strconcat("const ",oldname,NULL);
			g_free(oldname);
						;
    break;}
case 47:
#line 609 "parse.y"
{
			Node *node = new_type(0,yyvsp[0].id,NULL);
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 48:
#line 613 "parse.y"
{
			Node *node = new_type(stars,yyvsp[-1].id,NULL);
			stars = 0;
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 49:
#line 620 "parse.y"
{
			yyval.id = g_strconcat("unsigned ",yyvsp[0].id,NULL);
						;
    break;}
case 50:
#line 623 "parse.y"
{
			yyval.id = g_strconcat("signed ",yyvsp[0].id,NULL);
						;
    break;}
case 51:
#line 626 "parse.y"
{
			yyval.id = g_strdup(yyvsp[0].id);
						;
    break;}
case 52:
#line 629 "parse.y"
{
			yyval.id = g_strdup("unsigned char");
						;
    break;}
case 53:
#line 632 "parse.y"
{
			yyval.id = g_strdup("signed char");
						;
    break;}
case 54:
#line 635 "parse.y"
{
			yyval.id = g_strdup("char");
						;
    break;}
case 55:
#line 638 "parse.y"
{
			yyval.id = g_strdup("double");
						;
    break;}
case 56:
#line 641 "parse.y"
{
			yyval.id = g_strdup("float");
						;
    break;}
case 57:
#line 644 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 58:
#line 647 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id,yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
						;
    break;}
case 59:
#line 651 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 60:
#line 654 "parse.y"
{
			yyval.id = g_strdup("void");
						;
    break;}
case 61:
#line 659 "parse.y"
{
			yyval.id = "long int";
						;
    break;}
case 62:
#line 662 "parse.y"
{
			yyval.id = "long";
						;
    break;}
case 63:
#line 665 "parse.y"
{
			yyval.id = "short int";
						;
    break;}
case 64:
#line 668 "parse.y"
{
			yyval.id = "short";
						;
    break;}
case 65:
#line 671 "parse.y"
{
			yyval.id = "int";
						;
    break;}
case 66:
#line 676 "parse.y"
{
			yyval.id = "enum ";
						;
    break;}
case 67:
#line 679 "parse.y"
{
			yyval.id = "union ";
						;
    break;}
case 68:
#line 682 "parse.y"
{
			yyval.id = "struct ";
						;
    break;}
case 69:
#line 687 "parse.y"
{ stars++; ;
    break;}
case 70:
#line 688 "parse.y"
{ stars++; ;
    break;}
case 71:
#line 692 "parse.y"
{
			if(strcmp(yyvsp[-1].id, "first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id, "last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 72:
#line 704 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 73:
#line 710 "parse.y"
{
			if(strcmp(yyvsp[-1].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 74:
#line 722 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-2].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-2].id);
				YYERROR;
			}
			g_free(yyvsp[-2].id);
					;
    break;}
case 75:
#line 734 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 76:
#line 737 "parse.y"
{
			/* the_scope was default thus public */
			the_scope = PUBLIC_SCOPE;
					;
    break;}
case 77:
#line 743 "parse.y"
{
			gtktypes = g_list_prepend(gtktypes, yyvsp[-3].id);
						;
    break;}
case 78:
#line 748 "parse.y"
{
			gtktypes = g_list_append(gtktypes, yyvsp[0].id);
						;
    break;}
case 79:
#line 751 "parse.y"
{ 
			gtktypes = g_list_append(gtktypes, yyvsp[0].id);
       						;
    break;}
case 80:
#line 756 "parse.y"
{ yyval.cbuf = yyvsp[0].cbuf; ;
    break;}
case 81:
#line 757 "parse.y"
{ yyval.cbuf = NULL; ;
    break;}
case 82:
#line 761 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, yyvsp[-7].sigtype,NULL,
				      yyvsp[-5].id, yyvsp[0].cbuf,yyvsp[-9].line,
				      ccode_line, vararg, yyvsp[-8].list);
									;
    break;}
case 83:
#line 772 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, yyvsp[-7].sigtype, NULL,
				      yyvsp[-5].id, yyvsp[0].cbuf, yyvsp[-9].line,
				      ccode_line, vararg, yyvsp[-8].list);
									;
    break;}
case 84:
#line 783 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[0].cbuf, yyvsp[-8].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 85:
#line 794 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[0].cbuf, yyvsp[-7].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 86:
#line 805 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			push_function(PUBLIC_SCOPE, VIRTUAL_METHOD, NULL,
				      yyvsp[-5].id, yyvsp[0].cbuf, yyvsp[-7].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 87:
#line 816 "parse.y"
{
			push_function(NO_SCOPE, OVERRIDE_METHOD, yyvsp[-8].id,
				      yyvsp[-5].id, yyvsp[0].cbuf,
				      yyvsp[-10].line, ccode_line,
				      vararg, NULL);
									;
    break;}
case 88:
#line 822 "parse.y"
{
			push_function(the_scope, REGULAR_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[0].cbuf, yyvsp[-7].line, ccode_line,
				      vararg, NULL);
								;
    break;}
case 89:
#line 827 "parse.y"
{
			if(strcmp(yyvsp[-4].id, "init")==0) {
				push_init_arg(yyvsp[-2].id,FALSE);
				push_function(NO_SCOPE, INIT_METHOD, NULL,
					      yyvsp[-4].id, yyvsp[0].cbuf, yyvsp[-3].line,
					      ccode_line, FALSE, NULL);
			} else if(strcmp(yyvsp[-4].id, "class_init")==0) {
				push_init_arg(yyvsp[-2].id,TRUE);
				push_function(NO_SCOPE, CLASS_INIT_METHOD, NULL,
					      yyvsp[-4].id, yyvsp[0].cbuf, yyvsp[-3].line,
					      ccode_line, FALSE, NULL);
			} else {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				g_string_free(yyvsp[-2].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 90:
#line 848 "parse.y"
{
			g_free(onerror); onerror = NULL;
			g_free(defreturn); defreturn = NULL;
			if(!set_return_value(yyvsp[-1].id, yyvsp[0].id)) {
				g_free(yyvsp[-1].id);
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 91:
#line 859 "parse.y"
{
			g_free(onerror); onerror = NULL;
			g_free(defreturn); defreturn = NULL;
			if(!set_return_value(yyvsp[-3].id, yyvsp[-2].id)) {
				g_free(yyvsp[-3].id); g_free(yyvsp[-2].id);
				g_free(yyvsp[-1].id); g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			if(!set_return_value(yyvsp[-1].id, yyvsp[0].id)) {
				onerror = defreturn = NULL;
				g_free(yyvsp[-3].id); g_free(yyvsp[-2].id);
				g_free(yyvsp[-1].id); g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-3].id);
			g_free(yyvsp[-1].id);
						;
    break;}
case 92:
#line 878 "parse.y"
{
			g_free(onerror); onerror = NULL;
			g_free(defreturn); defreturn = NULL;
					;
    break;}
case 93:
#line 884 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 94:
#line 885 "parse.y"
{
			yyval.id = (yyvsp[1].cbuf)->str;
			g_string_free(yyvsp[1].cbuf, FALSE);
					;
    break;}
case 95:
#line 891 "parse.y"
{ vararg = FALSE; has_self = FALSE; ;
    break;}
case 96:
#line 892 "parse.y"
{
			vararg = FALSE;
			has_self = TRUE;
			if(strcmp(yyvsp[0].id,"self")==0)
				push_self(yyvsp[0].id);
			else {
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
       					;
    break;}
case 97:
#line 903 "parse.y"
{
			has_self = TRUE;
			if(strcmp(yyvsp[-2].id,"self")==0)
				push_self(yyvsp[-2].id);
			else {
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 98:
#line 913 "parse.y"
{ has_self = FALSE; ;
    break;}
case 99:
#line 916 "parse.y"
{ vararg = TRUE; ;
    break;}
case 100:
#line 917 "parse.y"
{ vararg = FALSE; ;
    break;}
case 101:
#line 920 "parse.y"
{ ; ;
    break;}
case 102:
#line 921 "parse.y"
{ ; ;
    break;}
case 103:
#line 924 "parse.y"
{
			push_funcarg(yyvsp[0].id,NULL);
								;
    break;}
case 104:
#line 927 "parse.y"
{
			push_funcarg(yyvsp[-1].id,yyvsp[0].id);
								;
    break;}
case 105:
#line 930 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-4].id,NULL);
								;
    break;}
case 106:
#line 938 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-5].id,yyvsp[-4].id);
								;
    break;}
case 107:
#line 948 "parse.y"
{ ; ;
    break;}
case 108:
#line 949 "parse.y"
{ ; ;
    break;}
case 109:
#line 952 "parse.y"
{
			if(strcmp(yyvsp[0].id,"type")==0) {
				Node *node = new_check(TYPE_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else if(strcmp(yyvsp[0].id,"null")==0) {
				Node *node = new_check(NULL_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[0].id);
					;
    break;}
case 110:
#line 965 "parse.y"
{
			Node *node = new_check(GT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 111:
#line 969 "parse.y"
{
			Node *node = new_check(LT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 112:
#line 973 "parse.y"
{
			Node *node = new_check(GE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 113:
#line 977 "parse.y"
{
			Node *node = new_check(LE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 114:
#line 981 "parse.y"
{
			Node *node = new_check(EQ_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 115:
#line 985 "parse.y"
{
			Node *node = new_check(NE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 116:
#line 991 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 117:
#line 992 "parse.y"
{
			yyval.id = g_strconcat("-",yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
					;
    break;}
case 118:
#line 996 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 999 "parse.y"

