/* GOB C Preprocessor
 * Copyright (C) 1999-2000 the Free Software Foundation.
 *
 * Author: George Lebl
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the  Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 */

#ifndef _UTIL_H_
#define _UTIL_H_

/* print an error, or warning (if 'is_warn') referring to 'line' */
void print_error(gboolean is_warn, char *error, int line);

/* remove the : separator from a typename */
char * remove_sep(char *base);
/* replace the : separator from a typename with a different character*/
char * replace_sep(char *base, char r);

/*separate the namespace part and then replace rest of
  separators with r*/
void separns_replace_sep(char *base, char **ns, char **name, char r);

/* make a macro with some prefix before the name but after
   namespace */
char * make_pre_macro(char *base, char *pre);

/* get a name usable for a cast from a GTK+ type (without GTK_TYPE_)*/
const char * get_cast(char *type, gboolean simple_only);

enum {
	SPECIAL_2POINTER,
	SPECIAL_3POINTER,
	SPECIAL_INT_POINTER,
	SPECIAL_LAST
};
/* returns TRUE if there are any special types at all */
gboolean setup_special_array(Class *c, gboolean *special_array);

#endif

